const aoijs = require('aoi.js');
const setting = require('./../../settings.js')

const bot = new aoijs.Bot({
  token: setting.BotToken,
  prefix: setting.BotPrefix,
  suppressAllErrors: setting.SuppressPackageErrors,
  sharding: setting.Sharding,
  shardCount: setting.ShardCount,
  errorMessage: "",
  intents: setting.BotIntents,
  respondOnEdit: setting.RespondOnEdit,    
  database: {
   db: require("dbdjs.db"),
   type: "dbdjs.db",
   path: "./Database/",
   tables: ["LinkScanningBotDB"],
 }
});

bot.onMessage({
 respondToBots: setting.RespondToBots
})
bot.onMessageUpdate()

const loader = new aoijs.LoadCommands(bot)
loader.load(bot.cmd,__dirname +"/Utils/")

bot.status({
 text: setting.BotStatus,
 type: setting.StatusType,
 status: "online",
 time: 12
})

bot.variables({
PackageVersion: "v0.0.8",
Prefix: setting.BotPrefix,
BotStatus: setting.BotStatus,
BotLogs: setting.BotLogs,
BotLogsChannelID: setting.BotLogsChannelID,
StatusType: setting.StatusType,
SuccessEmoji: setting.SuccessEmoji,
ErrorEmoji: setting.ErrorEmoji,
LoadingEmoji: setting.LoadingEmoji,
ApiKey: setting.ApiKey,
BotOwners: setting.BotOwners,
ServerLinkScan: setting.LinkScanning,
ServerLanguage: setting.BotLanguage,
RespondToBots: setting.RespondToBots,
CooldownBetweenScans: setting.CooldownBetweenScans,
IgnoreUsersWithPerms: setting.IgnoreUsersWithPerms,
IgnoreChannels: setting.IgnoreChannels,
DeleteIfMaliciousLink: setting.DeleteIfMaliciousLink,
BanIfMaliciousLink: setting.BanIfMaliciousLink,
TimeoutIfMaliciousLink: setting.TimeoutIfMaliciousLink,
TimeoutTime: setting.TimeoutTime,

BadLinksMessageID: ""
})


bot.command({
name: "$alwaysExecute", 
code: `
$if[$jsonRequest[https://ipqualityscore.com/api/json/url/$getVar[ApiKey]/$replaceText[$splitText[1];.-.;//];unsafe;]==true;{execute:BadLink};{execute:SecureLink}]

$onlyIf[$isValidLink[$replaceText[$splitText[1];.-.;//]]!=false;{execute:IfInvalidLink}]

$textSplit[$replaceText[$advancedTextSplit[$advancedTextSplit[$message;//;2]; ;1];//;.-.];/]

$setGlobalUserVar[BadLinksMessageID;$get[id]]
$wait[0.5s]
$let[id;$sendMessage[{
"embeds" : "{newEmbed:{description:$getVar[LoadingEmoji] **$if[$getVar[ServerLanguage]==Español;Escaneando enlace;$if[$getVar[ServerLanguage]==English;Scanning link;Link scannen]]...**}{color:YELLOW}}",
"reply" : {
"messageReference" : "$messageId"
}
};yes]]

$serverCooldown[$getVar[CooldownBetweenScans];]

$onlyIf[$checkContains[$message;https://;http://]!=false;]
$onlyIf[$hasAnyPerm[$guildID;$authorID;$getVar[IgnoreUsersWithPerms]]!=true;]
$onlyIf[$checkContains[$channelID;$getVar[IgnoreChannels]]!=true;]
$onlyIf[$getVar[ServerLinkScan]!=false;]
`
})

bot.awaitedCommand({
name: "IfInvalidLink",
code:`
$editMessage[$getGlobalUserVar[BadLinksMessageID];{newEmbed:{description:$getVar[ErrorEmoji] **__$if[$getVar[ServerLanguage]==Español;Ese link es inválido, por lo que no puedo escanearlo.;$if[$getVar[ServerLanguage]==English;That link is invalid, so I can't scan it.;Dieser Link ist ungültig, daher kann ich ihn nicht scannen.]].__**}{color:RED}}]
`
})

bot.awaitedCommand({
name: "SecureLink",
code:`
$editMessage[$getGlobalUserVar[BadLinksMessageID];{newEmbed:{description:$getVar[SuccessEmoji] **__$if[$getVar[ServerLanguage]==Español;No se han encontrado amenazas;$if[$getVar[ServerLanguage]==English;No malware found;Keine Malware gefunden]].__
$if[$getVar[ServerLanguage]==Español;Sospechoso;$if[$getVar[ServerLanguage]==English;Suspicious;Verdächtig]]: $jsonRequest[https://ipqualityscore.com/api/json/url/$getVar[ApiKey]/$replaceText[$splitText[1];.-.;//];suspicious;]**}{color:GREEN}}]
$textSplit[$replaceText[$advancedTextSplit[$advancedTextSplit[$message;//;2]; ;1];//;.-.];/]
`
})

bot.awaitedCommand({
name: "BadLink",
code:`
$channelSendMessage[$getVar[ServerLogs];{newEmbed:{color:YELLOW}{description: $getVar[NotifyEmoji] **$if[$getServerVar[ServerLanguage]==Español;El usuario <@$authorID> envió un enlace malicioso (<#$channelID>);$if[$getServerVar[ServerLanguage]==English;The user <@$authorID> sent a malicious link (<#$channelID>);Der Benutzer <@$authorID> hat einen schädlichen Link (<#$channelID>) gesendet.]]:**

$if[$getVar[BanIfMaliciousLink]!=false;{execute:BanIfMaliciousLink};]
$if[$getVar[TimeoutIfMaliciousLink]!=false;{execute:TimeoutIfMaliciousLink};]

$editMessage[$getGlobalUserVar[BadLinksMessageID];{newEmbed:{description:$getVar[ErrorEmoji] **$if[$getVar[ServerLanguage]==Español;<@$authorID> Ese es un enlace malicioso;$if[$getVar[ServerLanguage]==English;<@$authorID> That's a malicious link;<@$authorID> Das ist ein bösartiger Link]]:**
- **Parking:** $getObjectProperty[parking]
- **Spamming:** $getObjectProperty[spamming]
- **Malware:** $getObjectProperty[malware]
- **Phishing:** $getObjectProperty[phishing]}{color:RED}}]

$createObject[$jsonRequest[https://ipqualityscore.com/api/json/url/$getVar[ApiKey]/$replaceText[$splitText[1];.-.;//]]]
$textSplit[$replaceText[$advancedTextSplit[$advancedTextSplit[$message;//;2]; ;1];//;.-.];/]

$if[$getVar[DeleteIfMaliciousLink]!=false;{execute:DeleteIfMaliciousLink};]
`
})

bot.awaitedCommand({
name: "BanIfMaliciousLink",
code:`
$ban[$guildID;$authorID]
`
})

bot.awaitedCommand({
name: "DeleteIfMaliciousLink",
code:`
$deletecommand
`
})

bot.awaitedCommand({
name: "TimeoutIfMaliciousLink",
code:`
$timeOutMember[$guildID;$authorID;$getVar[TimeoutTime];no;$if[$getServerVar[ServerLanguage]==Español;Envió un enlace malicioso.;$if[$getServerVar[ServerLanguage]==English;Sent a malicious link.;Bad Link gesendet.]]]

`
})

bot.command({
name: "eval", 
code: `
$eval[$message]

$onlyForIDs[759796588842450944;$getVar[BotOwners];]
`
})